.686
.model flat,stdcall
option casemap:none

include windows.inc
include user32.inc
include kernel32.inc
include gdi32.inc
include masm32.inc
;/////////////////
include biglib.inc
;/////////////////

includelib user32.lib
includelib kernel32.lib
includelib gdi32.lib
includelib masm32.lib
;/////////////////
includelib biglib.lib
;/////////////////

DialogProc  PROTO :DWORD,:DWORD,:DWORD,:DWORD
Generate    PROTO :DWORD,:DWORD,:DWORD,:DWORD
MD5hash     PROTO :dword,:dword,:dword

MD5RESULT		STRUCT
	dtA		dd	?
	dtB		dd	?
	dtC		dd	?
	dtD		dd	?
MD5RESULT		ENDS


IDD_DIALOG1        equ             101
IDC_NAME           equ             1000
IDC_SERIAL         equ             1001
IDC_GENERATE       equ             1002
IDC_ABOUT          equ             1003
IDC_AUTHOR         equ             1004

CurDate		TEXTEQU	<">, @Date, <">

.data
;this bytes must be here for a reason
szname      db 100 dup (0)
serial      db 11 dup (0)
szserial    db 21 dup (0)
hmod        dd ?
font        LOGFONT <15,6,0,0,FW_BOLD>
sztitle     db "[Ninja Crackme by bart/xt] - kEYGEN",0
szbadname   db "Invalid name entered!",0
aboutcap    db "About:",0 
abouttxt    db "Program",09h,": Ninja Crackme by bart/xt",10,13
            db "Protection: RSA-324, MD5",10,13
            db "Difficulty",09h,": Quite easy (3/10)",10,13
            db "Date",09h,": ",CurDate,10,13,10,13
            db "...A KANAL23 RELEASE...",0
rsa_n       db "AB185AE9243F57C7428B7CE76B62A5E1321CA3A3F966659A8368BD3879241F35407599BDC49EA31A9",0
rsa_d       db "A5389CB9DD5609F7130CCE6E4FE5F057FA636BA68B5B14672C7BD4DC26666F9A6BE23E30E2F12A01D",0
.code
start:
    invoke GetModuleHandle,NULL
    mov hmod,eax
    invoke DialogBoxParam,eax,IDD_DIALOG1,NULL,addr DialogProc,NULL
    invoke ExitProcess,eax
DialogProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    LOCAL nobw:DWORD
    LOCAL crc:DWORD
	
    mov		eax,uMsg
    .if eax==WM_INITDIALOG
        invoke CreateFontIndirect,addr font
        push ebx
        xchg eax,ebx
        invoke SendDlgItemMessage,hWin,IDC_AUTHOR,WM_SETFONT,ebx,1
        invoke SendDlgItemMessage,hWin,IDC_NAME,WM_SETFONT,ebx,1
        invoke SendDlgItemMessage,hWin,IDC_SERIAL,WM_SETFONT,ebx,1
        invoke SendDlgItemMessage,hWin,IDC_NAME,EM_LIMITTEXT,32,0
        pop ebx
        invoke SetWindowText,hWin,addr sztitle
    .elseif eax==WM_COMMAND
        mov		eax,wParam
        mov		edx,eax
        shr		edx,16
        and		eax,0FFFFh
        .if edx==BN_CLICKED
            .if eax==IDC_GENERATE
                pushad
                invoke GetDlgItemText,hWin,IDC_NAME,addr szname,100
                .if eax!=0
                    invoke Generate,addr szname,addr szserial,addr rsa_d,addr rsa_n
                    .if eax
                        invoke SetDlgItemText,hWin,IDC_SERIAL,addr szserial
                    .else
                        invoke MessageBox,hWin,addr szbadname,NULL,MB_ICONERROR
                    .endif 
                .else
                    invoke MessageBox,hWin,addr szbadname,NULL,MB_ICONERROR
                .endif
                popad
            .elseif eax==IDC_ABOUT
                invoke MessageBox,hWin,addr abouttxt,addr aboutcap,MB_ICONINFORMATION
            .endif
       .endif
    .elseif eax==WM_CLOSE
        invoke EndDialog,hWin,NULL
    .else
        xor eax,eax
        ret
    .endif
    mov  eax,TRUE
    ret

DialogProc endp
Generate    PROC _name:DWORD,_serial:DWORD,_d:DWORD,_n:DWORD
    LOCAL md5:MD5RESULT
    LOCAL R:DWORD
    LOCAL D:DWORD
    LOCAL N:DWORD
    
    pushad
    invoke StrLen,_name
    mov ebx,eax
    xor esi,esi
    
;check if name is valid
;and if so convert it to upper case
    
is_name_valid:				; CODE XREF: Check+F8j
	mov	eax, _name
	movsx	edi, byte ptr [eax+esi]
	cmp	edi, 'a'
	jb	short loc_402584
	cmp	edi, 'z'
	ja	short loc_402584
	sub	edi, ' '

loc_402584:				; CODE XREF: Check+CAj	Check+CFj
	cmp	edi, ' '
	jz	short loc_4025A5
	cmp	edi, 'A'
	jb	short loc_402593
	cmp	edi, 'Z'
	jbe	short loc_40259D

loc_402593:				; CODE XREF: Check+DCj
	mov	eax, 0
	jmp	@end
; 

loc_40259D:				; CODE XREF: Check+E1j
	mov	eax, _name
	mov	edx, edi
	mov	[eax+esi], dl

loc_4025A5:				; CODE XREF: Check+D7j
	inc	esi

loc_4025A6:				; CODE XREF: Check+BEj
	cmp	esi, ebx
	jb	short is_name_valid
	
    ;hash name with md5 (courtesy of roy :))
    invoke MD5hash,_name,ebx,addr md5  
    ; bswap dwords from md5 because the hash in crackme
    ; is in little endian
    
    lea esi,md5
    mov edi,esi
    mov ecx,4
    @@:
    lodsd
    bswap eax
    stosd
    loop @B
        
    
    ; perform rsa decryption
    invoke _BigCreate,0
    mov R,eax
    invoke _BigCreate,0
    mov D,eax
    invoke _BigCreate,0
    mov N,eax
    
    invoke _BigInB256,addr md5,16,R
    invoke _BigIn,_d,16,D
    invoke _BigIn,_n,16,N
    invoke _BigPowMod,R,D,N,R
    invoke _BigOutB16,R,_serial
    invoke _BigDestroy,R
    invoke _BigDestroy,D
    invoke _BigDestroy,N
    xor eax,eax
    inc eax   
    @end:
    mov dword ptr [esp+01Ch],eax
    popad
    ret

Generate endp


FF			MACRO	dta,dtb,dtc,dtd,x,s,t				; a = b + ((a + F(b,c,d) + x + t) << s )

			mov	eax,dtb
			mov	ebx,dtc
			mov	ecx,dtd

			; F(x,y,z) = (x and y) or ((not x) and z)
			and	ebx,eax
			not	eax
			and	eax,ecx
			or	eax,ebx

			add	eax,dta
			add	eax,x
			add	eax,t

			mov	cl,s
			rol	eax,cl

			add	eax,dtb

			mov	dta,eax

ENDM

GG			MACRO	dta,dtb,dtc,dtd,x,s,t				; a = b + ((a + G(b,c,d) + x + t) << s)

			mov	eax,dtb
			mov	ebx,dtc
			mov	ecx,dtd

			; G(x,y,z) = (x and z) or (y and (not z))
			and	eax,ecx
			not	ecx
			and	ecx,ebx
			or	eax,ecx

			add	eax,dta
			add	eax,x
			add	eax,t

			mov	cl,s
			rol	eax,cl

			add	eax,dtb

			mov	dta,eax

ENDM

HH			MACRO	dta,dtb,dtc,dtd,x,s,t				; a = b + ((a + H(b,c,d) + x + t) << s)

			mov	eax,dtb
			mov	ebx,dtc
			mov	ecx,dtd

			; H(x,y,z) = x xor y xor z
			xor	eax,ebx
			xor	eax,ecx

			add	eax,dta
			add	eax,x
			add	eax,t

			mov	cl,s
			rol	eax,cl

			add	eax,dtb

			mov	dta,eax

ENDM

II			MACRO	dta,dtb,dtc,dtd,x,s,t				; a = b + ((a + I(b,c,d) + x + t) << s)

			mov	eax,dtb
			mov	ebx,dtc
			mov	ecx,dtd

			; I(x,y,z) = y xor (x or (not z))
			not	ecx
			or	eax,ecx
			xor	eax,ebx

			add	eax,dta
			add	eax,x
			add	eax,t

			mov	cl,s
			rol	eax,cl

			add	eax,dtb

			mov	dta,eax

ENDM

MD5hash			proc	uses eax ebx ecx edx edi esi,ptBuffer:dword,dtBufferLength:dword,ptMD5Result:dword
			local	dta:dword,dtb:dword,dtc:dword,dtd:dword

			; phase I  padding
			mov	edi,ptBuffer
			mov	eax,dtBufferLength

			inc	eax
			add	edi,eax
			mov	byte ptr [edi-1],080h

			xor	edx,edx

			mov	ebx,64
			div	ebx

			neg	edx
			add	edx,64

			cmp	edx,8
			jae	@f

			add	edx,64

@@:			mov	ecx,edx
			xor	al,al
			rep	stosb

			mov	eax,dtBufferLength

			inc	edx
			add	dtBufferLength,edx

			xor	edx,edx

			mov	ebx,8
			mul	ebx

			mov	dword ptr [edi-8],eax
			mov	dword ptr [edi-4],edx

			mov	edx,dtBufferLength

			mov	edi,ptBuffer

			; phase II  chaining variables initialization
			mov	esi,ptMD5Result
			assume	esi:ptr MD5RESULT

			mov	[esi].dtA,067452301h
			mov	[esi].dtB,0efcdab89h
			mov	[esi].dtC,098badcfeh
			mov	[esi].dtD,010325476h

			; phase III  hashing
hashloop:		mov	eax,[esi].dtA
			mov	dta,eax
			mov	eax,[esi].dtB
			mov	dtb,eax
			mov	eax,[esi].dtC
			mov	dtc,eax
			mov	eax,[esi].dtD
			mov	dtd,eax

			; round 1
			FF	dta,dtb,dtc,dtd,dword ptr [edi+00*4],07,0d76aa478h
			FF	dtd,dta,dtb,dtc,dword ptr [edi+01*4],12,0e8c7b756h
			FF	dtc,dtd,dta,dtb,dword ptr [edi+02*4],17,0242070dbh
			FF	dtb,dtc,dtd,dta,dword ptr [edi+03*4],22,0c1bdceeeh
			FF	dta,dtb,dtc,dtd,dword ptr [edi+04*4],07,0f57c0fafh
			FF	dtd,dta,dtb,dtc,dword ptr [edi+05*4],12,04787c62ah
			FF	dtc,dtd,dta,dtb,dword ptr [edi+06*4],17,0a8304613h
			FF	dtb,dtc,dtd,dta,dword ptr [edi+07*4],22,0fd469501h
			FF	dta,dtb,dtc,dtd,dword ptr [edi+08*4],07,0698098d8h
			FF	dtd,dta,dtb,dtc,dword ptr [edi+09*4],12,08b44f7afh
			FF	dtc,dtd,dta,dtb,dword ptr [edi+10*4],17,0ffff5bb1h
			FF	dtb,dtc,dtd,dta,dword ptr [edi+11*4],22,0895cd7beh
			FF	dta,dtb,dtc,dtd,dword ptr [edi+12*4],07,06b901122h
			FF	dtd,dta,dtb,dtc,dword ptr [edi+13*4],12,0fd987193h
			FF	dtc,dtd,dta,dtb,dword ptr [edi+14*4],17,0a679438eh
			FF	dtb,dtc,dtd,dta,dword ptr [edi+15*4],22,049b40821h

			; round 2
			GG	dta,dtb,dtc,dtd,dword ptr [edi+01*4],05,0f61e2562h
			GG	dtd,dta,dtb,dtc,dword ptr [edi+06*4],09,0c040b340h
			GG	dtc,dtd,dta,dtb,dword ptr [edi+11*4],14,0265e5a51h
			GG	dtb,dtc,dtd,dta,dword ptr [edi+00*4],20,0e9b6c7aah
			GG	dta,dtb,dtc,dtd,dword ptr [edi+05*4],05,0d62f105dh
			GG	dtd,dta,dtb,dtc,dword ptr [edi+10*4],09,002441453h
			GG	dtc,dtd,dta,dtb,dword ptr [edi+15*4],14,0d8a1e681h
			GG	dtb,dtc,dtd,dta,dword ptr [edi+04*4],20,0e7d3fbc8h
			GG	dta,dtb,dtc,dtd,dword ptr [edi+09*4],05,021e1cde6h
			GG	dtd,dta,dtb,dtc,dword ptr [edi+14*4],09,0c33707d6h
			GG	dtc,dtd,dta,dtb,dword ptr [edi+03*4],14,0f4d50d87h
			GG	dtb,dtc,dtd,dta,dword ptr [edi+08*4],20,0455a14edh
			GG	dta,dtb,dtc,dtd,dword ptr [edi+13*4],05,0a9e3e905h
			GG	dtd,dta,dtb,dtc,dword ptr [edi+02*4],09,0fcefa3f8h
			GG	dtc,dtd,dta,dtb,dword ptr [edi+07*4],14,0676f02d9h
			GG	dtb,dtc,dtd,dta,dword ptr [edi+12*4],20,08d2a4c8ah

			; round 3
			HH	dta,dtb,dtc,dtd,dword ptr [edi+05*4],04,0fffa3942h
			HH	dtd,dta,dtb,dtc,dword ptr [edi+08*4],11,08771f681h
			HH	dtc,dtd,dta,dtb,dword ptr [edi+11*4],16,06d9d6122h
			HH	dtb,dtc,dtd,dta,dword ptr [edi+14*4],23,0fde5380ch
			HH	dta,dtb,dtc,dtd,dword ptr [edi+01*4],04,0a4beea44h
			HH	dtd,dta,dtb,dtc,dword ptr [edi+04*4],11,04bdecfa9h
			HH	dtc,dtd,dta,dtb,dword ptr [edi+07*4],16,0f6bb4b60h
			HH	dtb,dtc,dtd,dta,dword ptr [edi+10*4],23,0bebfbc70h
			HH	dta,dtb,dtc,dtd,dword ptr [edi+13*4],04,0289b7ec6h
			HH	dtd,dta,dtb,dtc,dword ptr [edi+00*4],11,0eaa127fah
			HH	dtc,dtd,dta,dtb,dword ptr [edi+03*4],16,0d4ef3085h
			HH	dtb,dtc,dtd,dta,dword ptr [edi+06*4],23,004881d05h
			HH	dta,dtb,dtc,dtd,dword ptr [edi+09*4],04,0d9d4d039h
			HH	dtd,dta,dtb,dtc,dword ptr [edi+12*4],11,0e6db99e5h
			HH	dtc,dtd,dta,dtb,dword ptr [edi+15*4],16,01fa27cf8h
			HH	dtb,dtc,dtd,dta,dword ptr [edi+02*4],23,0c4ac5665h

			; round 4
			II	dta,dtb,dtc,dtd,dword ptr [edi+00*4],06,0f4292244h
			II	dtd,dta,dtb,dtc,dword ptr [edi+07*4],10,0432aff97h
			II	dtc,dtd,dta,dtb,dword ptr [edi+14*4],15,0ab9423a7h
			II	dtb,dtc,dtd,dta,dword ptr [edi+05*4],21,0fc93a039h
			II	dta,dtb,dtc,dtd,dword ptr [edi+12*4],06,0655b59c3h
			II	dtd,dta,dtb,dtc,dword ptr [edi+03*4],10,08f0ccc92h
			II	dtc,dtd,dta,dtb,dword ptr [edi+10*4],15,0ffeff47dh
			II	dtb,dtc,dtd,dta,dword ptr [edi+01*4],21,085845dd1h
			II	dta,dtb,dtc,dtd,dword ptr [edi+08*4],06,06fa87e4fh
			II	dtd,dta,dtb,dtc,dword ptr [edi+15*4],10,0fe2ce6e0h
			II	dtc,dtd,dta,dtb,dword ptr [edi+06*4],15,0a3014314h
			II	dtb,dtc,dtd,dta,dword ptr [edi+13*4],21,04e0811a1h
			II	dta,dtb,dtc,dtd,dword ptr [edi+04*4],06,0f7537e82h
			II	dtd,dta,dtb,dtc,dword ptr [edi+11*4],10,0bd3af235h
			II	dtc,dtd,dta,dtb,dword ptr [edi+02*4],15,02ad7d2bbh
			II	dtb,dtc,dtd,dta,dword ptr [edi+09*4],21,0eb86d391h

			mov	eax,dta
			add	[esi].dtA,eax
			mov	eax,dtb
			add	[esi].dtB,eax
			mov	eax,dtc
			add	[esi].dtC,eax
			mov	eax,dtd
			add	[esi].dtD,eax

			add	edi,64

			sub	edx,64
			jnz	hashloop

			; phase IV  results

			mov	ecx,4

@@:			mov	eax,dword ptr [esi]
			xchg	al,ah
			rol	eax,16
			xchg	al,ah
			mov	dword ptr [esi],eax

			add	esi,4

			loop	@b

			ret

MD5hash			endp


end start